/*	TRIE.H - definition of generic trie structure
 ***************************************************************************
 *	EDIT HISTORY
 *	19-May-89	Steve McConnel
 ***************************************************************************
 * Copyright 1989 by the Summer Institute of Linguistics, Inc.
 * All rights reserved.
 */

/****************************************************************************
 *  This is the base structure used in generic tries.
 */
struct trienode
    {
    char *letters;		/* string of letters at this node */
    struct trienode *children;	/* pointer to children trie nodes */
    struct trienode *siblings;	/* pointer to sibling trie nodes */
    void *trieinfo;		/* pointer to information stored here */
    };

typedef struct trienode TRIE;

extern TRIE *add_to_trie();
extern void *search_trie();
extern void  show_trie();
